Index: NetworkManager-0.7.1/policy/org.freedesktop.network-manager-settings.system.policy.in
===================================================================
--- NetworkManager-0.7.1.orig/policy/org.freedesktop.network-manager-settings.system.policy.in
+++ NetworkManager-0.7.1/policy/org.freedesktop.network-manager-settings.system.policy.in
@@ -18,4 +18,154 @@
     </defaults>
   </action>
 
+  <action id="org.freedesktop.network-manager-settings.system.wired.modify">
+    <_description>Modify system wired connections</_description>
+    <_message>System policy prevents modification of system wired connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.wireless.modify">
+    <_description>Modify system wired connections</_description>
+    <_message>System policy prevents modification of system wired connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.mobile.modify">
+    <_description>Modify system mobile connections</_description>
+    <_message>System policy prevents modification of system mobile connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.vpn.modify">
+    <_description>Modify system vpn connections</_description>
+    <_message>System policy prevents modification of system vpn connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.system.dsl.modify">
+    <_description>Modify system dsl connections</_description>
+    <_message>System policy prevents modification of system dsl connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wired.apply">
+    <_description>Apply user wired connections</_description>
+    <_message>System policy prevents using of user wired connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wireless.apply">
+    <_description>Apply user wireless connections</_description>
+    <_message>System policy prevents using of user wireless connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.mobile.apply">
+    <_description>Apply user mobile connections</_description>
+    <_message>System policy prevents using of user mobile connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.vpn.apply">
+    <_description>Apply user vpn connections</_description>
+    <_message>System policy prevents using of user vpn connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.dsl.apply">
+    <_description>Apply user dsl connections</_description>
+    <_message>System policy prevents using of user dsl connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>yes</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wired.apply-with-share">
+    <_description>Apply user wired connections</_description>
+    <_message>System policy prevents using of user wired connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.wireless.apply-with-share">
+    <_description>Apply user wireless connections</_description>
+    <_message>System policy prevents using of user wireless connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.mobile.apply-with-share">
+    <_description>Apply user mobile connections</_description>
+    <_message>System policy prevents using of user mobile connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.vpn.apply-with-share">
+    <_description>Apply user vpn connections</_description>
+    <_message>System policy prevents using of user vpn connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
+  <action id="org.freedesktop.network-manager-settings.user.dsl.apply-with-share">
+    <_description>Apply user dsl connections</_description>
+    <_message>System policy prevents using of user dsl connections</_message>
+    <vendor>NetworkManager Novell Inc.</vendor>
+    <defaults>
+      <allow_inactive>no</allow_inactive>
+      <allow_active>auth_admin_keep_always</allow_active>
+    </defaults>
+  </action>
+
 </policyconfig>